<%@ page import="org.wso2.carbon.ui.CarbonUIMessage" %>
<%@ page import="org.wso2.carbon.utils.ServerConstants" %>
<%@ page import="org.wso2.carbon.CarbonConstants" %>
<%@ page import="org.apache.axis2.context.ConfigurationContext" %>
<%@ page import="org.wso2.carbon.ui.CarbonUIUtil" %>
<%@ page import="org.wso2.carbon.component.mgt.ui.ProvisioningAdminClient" %>
<%@ page import="org.wso2.carbon.component.mgt.ui.prov.data.RepositoryInfo" %>
<%@ page import="org.wso2.carbon.component.mgt.ui.RepositoryAdminServiceClient" %>
<%@ page import="org.wso2.carbon.component.mgt.ui.prov.data.ProfileHistory" %>
<%@ page import="org.wso2.carbon.component.mgt.ui.prov.data.Feature" %>
<%@ page import="org.wso2.carbon.component.mgt.ui.FeatureWrapper" %>
<%@ page import="java.util.Stack" %>
<%@ page import="org.wso2.carbon.component.mgt.ui.util.Utils" %>
<%@ taglib prefix="fmt" uri="http://java.sun.com/jsp/jstl/fmt" %>
<%@ taglib uri="http://wso2.org/projects/carbon/taglibs/carbontags.jar" prefix="carbon" %>

<!--Yahoo includes for dom event handling-->
<script src="../yui/build/yahoo-dom-event/yahoo-dom-event.js" type="text/javascript"></script>

<script src="js/tableTree.js" type="text/javascript"></script>

<script type="text/javascript" src="../admin/js/main.js"></script>
<script type="text/javascript" src="../admin/js/prototype-1.6.js"></script>

<%
    int maxheight;
    boolean disableNext = true;
    RepositoryAdminServiceClient repositoryAdminClient;
    ProvisioningAdminClient provAdminClient;
    RepositoryInfo[] repositories = null;
    RepositoryInfo[] allRepositories = null;
    FeatureWrapper[] featureWrappers = null;

    String backendServerURL = CarbonUIUtil.getServerURL(config.getServletContext(), session);
    ConfigurationContext configContext =
            (ConfigurationContext) config.getServletContext().getAttribute(CarbonConstants.CONFIGURATION_CONTEXT);
    String cookie = (String) session.getAttribute(ServerConstants.ADMIN_SERVICE_COOKIE);

    try {
        repositoryAdminClient = new RepositoryAdminServiceClient(cookie, backendServerURL, configContext, request.getLocale());
        repositories = repositoryAdminClient.getEnabledRepositories();

        //TODO refactor this code. last minute change, before the release. Hence no time to do refactoring.
        //TODO two service calls,
        allRepositories = repositoryAdminClient.getAllRepositories();

        provAdminClient = new ProvisioningAdminClient(cookie, backendServerURL, configContext, request.getLocale());
        featureWrappers = provAdminClient.getInstalledFeatures();
        request.getSession(true).setAttribute(ProvisioningAdminClient.INSTALLED_FEATURES, featureWrappers);
        maxheight = Utils.getMaxHeight(featureWrappers, 0);
     } catch (Exception e) {
        CarbonUIMessage.sendCarbonUIMessage(e.getMessage(), CarbonUIMessage.ERROR, request, e);
%>
<script type="text/javascript">
       location.href = "../admin/error.jsp";
</script>
<%
        return;
    }
%>
<fmt:bundle basename="org.wso2.carbon.component.mgt.ui.i18n.Resources">
<carbon:breadcrumb label="comp.management"
        resourceBundle="org.wso2.carbon.component.mgt.ui.i18n.Resources"
        topPage="true" request="<%=request%>" />

<link type="text/css" href="css/ui.all.css" rel="stylesheet" />
<script type="text/javascript" src="js/jquery-1.2.6.min.js"></script>
<script type="text/javascript" src="js/jquery-ui-1.6.custom.min.js"></script>
<script type="text/javascript" src="js/comp-mgt-utils.js"></script>
<div id="middle">
    <h2><fmt:message key="comp.management"/></h2>
    <div id="workArea">
        <div id="tabs">

			<ul>
				<li><a href="#tabs-1"><fmt:message key="available.features"/></a></li>
				<li><a href="#tabs-2"><fmt:message key="installed.features"/></a></li>
                <li><a href="#tabs-3"><fmt:message key="installation.history"/></a></li>
                <li><a href="#tabs-4"><fmt:message key="settings"/></a></li>
			</ul>

            <div id="tabs-1">

                <div id="_div_tabs01-step-00-FR">
                    <H4><strong><fmt:message key="available.features"/></strong></H4>
                    <p><font color="#707277"><i><fmt:message key="available.features.description"/></i></font></p>
                    <br/>
                    <div id="_div_filter_repositories">
                        <table class="normal" width="100%">
                            <tbody>
                            <tr>
                                <td><nobr><fmt:message key="repository"/>:&nbsp;&nbsp;&nbsp;
                                    <select id="_select_repositoryCombo" tabindex="5" style="width: 500px">
                                        <%  if(repositories == null ){
                                        %>
                                        <option value="NO_REPO" selected="true"><fmt:message key="no.repositories.found"/>
                                        </option>
                                        <%
                                            } else {
                                                disableNext = false;
                                        %>
                                        <option value="ALL_REPOS" selected="true">All Available
                                            Repositories
                                        </option>
                                        <%
                                                for(RepositoryInfo repository: repositories){
                                                    String nickName = repository.getNickName();
                                                    String location = repository.getLocation();
                                        %>
                                        <option value="<%=location%>"><%=nickName%> - <%=location%>
                                        </option>
                                        <%
                                                }
                                            }
                                        %>
                                    </select>&nbsp;&nbsp;<a href="#" class="icon-link"  style="background-image: url(images/add.gif);float:none;"
                                            onclick="$myTabs.tabs('select', 3);swapVisiblility('_div_tabs04-MR', '_div_tabs04-AR', 4); addRepositoryOnCompleteReturnTabID='AF';"><fmt:message key="add.new.repository"/></a></nobr>
                                </td>
                            </tr>
                            <tr>
                                <td><input id="_chk_show_latest" class="toolsClass" type="checkbox"/>&nbsp;&nbsp;&nbsp;<fmt:message key="latest.version"/>
                                </td>
                            </tr>
                            <tr>
                                <td class="border">&nbsp;</td>
                            </tr>
                            <tr>
                                <td height="12"></td>
                            </tr>
                            <tr>
                                <td class="buttonRow">
                                    <input value="<fmt:message key="find.features"/>" tabindex="11" type="button"
                                           class="button" <%=(disableNext)?"disabled='true'":""%>
                                           onclick="CARBON.showInfoDialog('<fmt:message key="loading.features"/>....');doNext('FR-AF');"
                                           id="_btn_next_filter_repositories">
                                </td>
                            </tr>
                            </tbody>
                        </table>
                    </div>

                    <div id="_div_tabs01-step-01-AF" style="display:none">
                    </div>
                </div>

                <div id="_div_tabs01-step-02-RF" style="display:none">
                </div>

                <div id="_div_tabs01-step-03-RL" style="display:none">
                </div>

                <div id="_div_tabs01-step-04-INSTALLING" style="display:none">
                    <table class="styledLeft" cellspacing="1" width="100%" id="_table_installing"
                               style="margin-left: 0px;">
                        <thead>
                            <tr>
                                <th><H4><strong><fmt:message key="installing"/></strong></H4></th>
                            </tr>
                        </thead>
                        <tbody>
                            <tr>
                                <td><fmt:message key="installing.description"/></td>
                            </tr>
                        </tbody>
                    </table>
                </div>

                <div id="_div_tabs01-step-05-IC" style="display:none">
                    <table class="styledLeft" cellspacing="1" width="100%" id="_table_Installation_Complete"
                               style="margin-left: 0px;">
                        <thead>
                            <tr>
                                <th><H4><strong><fmt:message key="installation.complete"/></strong></H4></th>
                            </tr>
                        </thead>
                        <tbody>
                            <tr>
                                <td>
                                    <table class="normal" cellspacing="1" width="100%" id="_table_Installation_Complete_details"
                                       style="margin-left: 0px;">
                                        <tbody>
                                            <tr>
                                                <td><fmt:message key="succesfully.installed.description"/></td>
                                            </tr>
                                            <tr>
                                                <td><fmt:message key="restart.the.server"/></td>
                                            </tr>
                                        </tbody>
                                     </table>
                                </td>
                            </tr>
                        <tr>
                             <td class="buttonRow">
                                <input value="<fmt:message key="finish.button"/>" tabindex="11" type="button"
                                       class="button"
                                       onclick="doBack('IC-AF')"
                                       id="_btn_ic_finish"/>
                            </td>
                        </tr>
                        </tbody>
                    </table>
                </div>

                <div id="_div_tabs01-FD" style="display:none">
                </div>

            </div>

			<div id="tabs-2">

                <div id="_div_tabs02-IF">
                    <H4><strong><fmt:message key="installed.features"/></strong></H4>
                    <p><font color="#707277"><i><fmt:message key="installed.features.description"/></i></font></p>
                    <br/>
                    <div id="_div_installed_features_list">

                        <table class="styledLeft" cellspacing="1" width="100%" id="_table_installed_features_list_main"
                               style="margin-left: 0px;">
                            <tbody>
                            <tr>
                                <td class="buttonRow">
                                    <select id="_select_feature_type_top" tabindex="5" style="width: 150px" onchange="onChangeTopSelectBoxUninstallableFeatures(this.value);">
                                        <option value="SELECTED_FEATURES" selected="true"><fmt:message key="selected.features"/>
                                        </option>
                                        <option value="SERVER_FEATURES"><fmt:message key="all.server.features"/>
                                        </option>
                                        <option value="CONSOLE_FEATURES"><fmt:message key="all.console.features"/>
                                        </option>
                                    </select>&nbsp;&nbsp;&nbsp;
                                    <input value="<fmt:message key="uninstall.buttion"/>" tabindex="11" type="button"
                                           class="button" disabled="true"
                                           onclick="doUninstall();"
                                           id="_btn_uninstall_installed_features_top">
                                </td>
                            </tr>
                            <tr>
                                <td>
                                    <a style="cursor: pointer;" onclick="selecteAllUninstallableFeatures(true);return false;" href="#"><fmt:message key="select.all"/></a>
                                    <b>|&nbsp;</b>
                                    <%--<a style="cursor: pointer;" href="#" onclick="reviewUninstallationFeaturesWithPropertiesPlan('org.wso2.carbon.p2.category.type', 'server');"><fmt:message key="all.server.features"/></a>--%>
                                    <%--<b>|&nbsp;</b>--%>
                                    <%--<a style="cursor: pointer;" href="#" onclick="reviewUninstallationFeaturesWithPropertiesPlan('org.wso2.carbon.p2.category.type', 'console');"><fmt:message key="all.console.features"/></a>--%>
                                    <%--<b>|&nbsp;</b>--%>
                                    <a style="cursor: pointer;" onclick="selecteAllUninstallableFeatures(false);return false;" href="#"><fmt:message key="select.none"/></a>
                                </td>
                            </tr>
                            <tr>
                                <td style="padding:0px !important;">
                                    <table class="styledLeft" cellspacing="1" width="100%" id="_table_installed_features_list"
                                           style="margin-left: 0px;">
                                        <thead>
                                                <tr>
                                                    <th colspan="<%=maxheight + 3%>"><div style="position:absolute;"><fmt:message key="name"/>
                                                        <input id="_txt_IF_filterString" class="log-select" type="text" size="40" value=""
                                                               onkeypress="submitenter(event, true)"/>&nbsp;
                                                        <input value="<fmt:message key="search.button"/>" tabindex="11" type="button"
                                                           class="button"
                                                           onclick="searchInstalledFeatures();"
                                                           id="_btn_search_installed_features_top"></div>
                                                    </th>
                                                    <th><fmt:message key="version"/></th>
                                                    <th><fmt:message key="provider"/></th>
                                                    <th><fmt:message key="actions"/></th>
                                                </tr>
                                                </thead>
                                                <tbody id="_table_installed_features_list_body">
                                    <%
                                        if(featureWrappers == null || featureWrappers.length == 0){
                                    %>
                                            <tr>
                                                <td colspan="0"><fmt:message key="no.features.availables"/></td>
                                            </tr>
                                    <%
                                        } else {
                                            for (FeatureWrapper featureWrapper : featureWrappers) {
                                                Stack<FeatureWrapper> stack = new Stack<FeatureWrapper>();
                                                stack.add(featureWrapper);
                                                while (!stack.isEmpty()) {
                                                    FeatureWrapper popedFeature = stack.pop();
                                                    Feature feature = popedFeature.getWrappedFeature();
                                                    String featureVersion = feature.getFeatureVersion();
                                                    String featureID = feature.getFeatureID();
                                                    int height = popedFeature.getHeight();
                                                    boolean hasChildren = popedFeature.hasChildren();
                                                    if(height == 0){
                                     %>
                                            <tr>
                                     <%

                                                    } else {
                                      %>
                                            <tr style="display:none; background-color:#fff;">
                                     <%
                                                    }
                                                    for(int i = 0; i < height; i++){
                                     %>
                                                <td class="ui-tableNoBorderCol" style="padding-right:0px !important;width:5px !important;">&nbsp;</td>
                                     <%
                                                    }
                                                    if(hasChildren){
                                     %>
                                                <td class="ui-tableNoBorderCol" style="padding-right:0px !important;width:5px !important;"><img src="images/plus.gif" style="cursor:pointer;" style="cursor:pointer" onclick="collapseTree(this)" class="ui-plusMinusIcon" /></td>
                                     <%
                                                    } else {

                                     %>
                                                <td class="ui-tableNoBorderCol" style="padding-right:0px !important;padding-left:0px !important;width:20px !important;">&nbsp;</td>
                                     <%
                                                    }

                                                    if(height != 0){
                                     %>
                                                <td class="ui-tableNoBorderCol" style="padding-right:0px !important;padding-left:0px !important;width:20px !important;">&nbsp;</td>

                                     <%
                                                   } else {
                                     %>

                                                <td class="ui-tableNoBorderCol" style="padding-right:0px !important;padding-left:0px !important;width:20px !important;">
                                                    <input class="checkbox-select" type="checkbox"
                                                           name="chkSelectFeaturesToUninstall"
                                                           <%=(height != 0)?"disabled='disabled'":""%>
                                                           value="<%=feature.getFeatureID()%>::<%=feature.getFeatureVersion()%>"
                                                           onclick="checkBoxSelectedUninstall(this);"/></td>
                                     <%
                                                    }
                                     %>

                                                <td colspan="<%=((maxheight + 3) - (height + 2))%>" class="featureNameCol"><%=feature.getFeatureName()%></td>   <%--featureNameCol is not for styling it's to get the elements from client side--%>
                                                <td><%=featureVersion%></td>
                                                <td><%=feature.getProvider()%></td>
                                                <td>
                                                    <a class="icon-link" style="background-image: url(images/more-info.gif);"
                                                           href="#" onclick="loadSelectedFeatureDetails('<%=featureID%>','<%=featureVersion%>', true, '_div_tabs02-FD', '_div_tabs02-IF', 2);"><fmt:message key="more.info"/></a>
                                                </td>
                                            </tr>
                                    <%
                                                    FeatureWrapper[] requiredFeatures = popedFeature.getRequiredFeatures();
                                                    if(requiredFeatures != null && requiredFeatures.length > 0){
                                                        for(FeatureWrapper requiredFeature: requiredFeatures){
                                                            stack.push(requiredFeature);
                                                        }
                                                    }
                                                }
                                            }
                                        }
                                    %>
                                            </tbody>
                                        </table>
                                    </td>
                                </tr>
                                <tr>
                                    <td class="buttonRow">
                                        <select id="_select_feature_type_bottom" tabindex="5" style="width: 150px" onchange="onChangeBottomSelectBoxUninstallableFeatures(this.value);">
                                        <option value="SELECTED_FEATURES" selected="true">Selected Features
                                        </option>
                                        <option value="SERVER_FEATURES">All Server Features
                                        </option>
                                        <option value="CONSOLE_FEATURES">All Console Features
                                        </option>
                                    </select>&nbsp;&nbsp;&nbsp;
                                        <input value="<fmt:message key="uninstall.buttion"/>" tabindex="11" type="button"
                                               class="button"i disabled="true"
                                               onclick="doUninstall();"
                                               id="_btn_uninstall_installed_features_bottom">
                                    </td>
                                </tr>
                                </tbody>
                            </table>
                    </div>
                </div>

                <div id="_div_tabs02-RUF" style="display:none">
                </div>

                <div id="_div_tabs02-FD" style="display:none">
                </div>

                <div id="_div_tabs02-UNINSTALLING" style="display:none">
                    <table class="styledLeft" cellspacing="1" width="100%" id="_table_uninstalling"
                               style="margin-left: 0px;">
                        <thead>
                            <tr>
                                <th><H4><strong><fmt:message key="uninstalling"/></strong></H4></th>
                            </tr>
                        </thead>
                        <tbody>
                            <tr>
                                <td><fmt:message key="uninstalling.description"/></td>
                            </tr>
                        </tbody>
                    </table>
                </div>

                <div id="_div_tabs02-UC" style="display:none">
                    <table class="styledLeft" cellspacing="1" width="100%" id="_table_Uninstallation_Complete"
                               style="margin-left: 0px;">
                        <thead>
                            <tr>
                                <th><H4><strong><fmt:message key="uninstallation.complete"/></strong></H4></th>
                            </tr>
                        </thead>
                        <tbody>
                            <tr>
                                <td>
                                    <table class="normal" cellspacing="1" width="100%" id="_table_Unnstallation_Complete_details"
                                       style="margin-left: 0px;">
                                        <tbody>
                                            <tr>
                                                <td><fmt:message key="uninstalled.message"/></td>
                                            </tr>
                                            <tr>
                                                <td><fmt:message key="restart.the.server"/></td>
                                            </tr>
                                        </tbody>
                                     </table>
                                </td>
                            </tr>
                        <tr>
                             <td class="buttonRow">
                                <input value="<fmt:message key="finish.button"/>" tabindex="11" type="button"
                                       class="button"
                                       onclick="doBack('UC-IF')"
                                       id="_btn_uc_finish"/>
                            </td>
                        </tr>
                        </tbody>
                    </table>
                </div>

            </div>

            <dir id="tabs-3">

                <div id="_div_tabs03-IH" style="display:none"></div>

                <div id="_div_tabs03-Loading-IH" >
                    <H4><strong><fmt:message key="installation.history"/></strong></H4>
                    <table class="styledLeft" cellspacing="1" width="100%" id="_table_loading-IH"
                               style="margin-left: 0px;">
                        <%--<thead>--%>
                            <%--<tr>--%>
                                <%--<th><H4><strong><fmt:message key="installing"/></strong></H4></th>--%>
                            <%--</tr>--%>
                        <%--</thead>--%>
                        <tbody>
                            <tr>
                                <td><fmt:message key="loading"/>...</td>
                            </tr>
                        </tbody>
                    </table>
                </div>

                <div id="_div_tabs03-RP" style="display:none" >
                </div>

                <div id="_div_tabs03-FD" style="display:none">
                </div>

                <div id="_div_tabs03-RC" style="display:none">
                    <table class="styledLeft" cellspacing="1" width="100%" id="_table_revert_Complete"
                               style="margin-left: 0px;">
                        <thead>
                            <tr>
                                <th><H4><strong><fmt:message key="reverting.is.completed"/></strong></H4></th>
                            </tr>
                        </thead>
                        <tbody>
                            <tr>
                                <td>
                                    <table class="normal" cellspacing="1" width="100%" id="_table_revert_Complete_details"
                                       style="margin-left: 0px;">
                                        <tbody>
                                            <tr>
                                                <td><fmt:message key="reverting.completed.description"/></td>
                                            </tr>
                                            <tr>
                                                <td><fmt:message key="restart.the.server"/></td>
                                            </tr>
                                        </tbody>
                                     </table>
                                </td>
                            </tr>
                        <tr>
                             <td class="buttonRow">
                                <input value="<fmt:message key="finish.button"/>" tabindex="11" type="button"
                                       class="button"
                                       onclick="doBack('RC-IH')"
                                       id="_btn_rc_finish"/>
                            </td>
                        </tr>
                        </tbody>
                    </table>
                </div>

            </dir>

            <div id="tabs-4">

                <%--<div id="_div_tabs04-MAIN">--%>
                    <%--<H4><strong><fmt:message key="settings"/></strong></H4>--%>
                    <%--<p><font color="#707277"><i><fmt:message key="settings.description"/></i></font></p>--%>
                    <%--<br/>--%>
                    <%--<div id="_div_settings">--%>
                            <%--<table class="normal" cellspacing="1" width="100%" id="_table_settings"--%>
                                   <%--style="margin-left: 0px;">--%>
                                <%--<tbody>--%>
                                <%--<tr>--%>
                                    <%--<td><a class="icon-link" href="#" onclick="loadRepositories();"--%>
                                           <%--style="background-image: url(images/add.gif);"><fmt:message key="manage.repositories"/></a></td>--%>
                                <%--</tr>--%>
                                <%--</tbody>--%>
                            <%--</table>--%>
                        <%--</div>--%>
                    <%--<br/>--%>
			    <%--</div>--%>

                <div id="_div_tabs04-MR">
                    <table class="styledLeft" cellspacing="1" width="100%"
                               id="_table_manage_repositories" style="margin-left: 0px;">
                        <thead>
                            <tr>
                                <th><fmt:message key="manage.repositories"/></th>
                            </tr>
                        </thead>
                        <tbody>
                            <tr>
                                <td><table class="normal" cellspacing="1" width="100%" id="_table_add_repository_link"
                                       style="margin-left: 0px;">
                                    <tbody>
                                    <tr><td><font color="#707277"><i><fmt:message key="manage.repositories.description"/></i></font></td></tr>
                                    <br/>
                                    <tr>
                                        <td><a class="icon-link" href="#" onclick="swapVisiblility('_div_tabs04-MR', '_div_tabs04-AR', 4);addRepositoryOnCompleteReturnTabID='SETTINGS';"
                                               style="background-image: url(images/add.gif);"><fmt:message key="add.new.repository"/></a></td>
                                    </tr>
                                    <tr><td><fmt:message key="available.repositories"/></td></tr>
                                    <tr><td>
                                        <div id="_div_repository_list">
                                            <table class="styledLeft" cellspacing="1" width="100%" id="_table_repository_list"
                                                                                   style="margin-left: 0px;">
                                                <thead>
                                                <tr>
                                                    <th><fmt:message key="name"/></th>
                                                    <th><fmt:message key="location"/></th>
                                                    <th><fmt:message key="enabled"/></th>
                                                    <th colspan="4"><fmt:message key="actions"/></th>
                                                </tr>
                                                </thead>
                                                <tbody>

                                                <%
                                                    if(allRepositories == null || allRepositories.length == 0){
                                                %>
                                                <tr>
                                                    <td colspan="0"><fmt:message key="no.available.repositories"/>.</td>
                                                </tr>
                                                <%
                                                    } else {
                                                        for(RepositoryInfo repository:allRepositories){
                                                            String location = repository.getLocation();
                                                            String repoNickName = repository.getNickName();
                                                            boolean enabled = repository.getEnabled();
                                                            String status;
                                                            if(enabled){
                                                                status =  RepositoryAdminServiceClient.ENABLED;
                                                            } else {
                                                                status = RepositoryAdminServiceClient.DISABLED;
                                                            }

                                                            String oppositeStatus = (RepositoryAdminServiceClient.ENABLED.equals(
                                                                    status))?RepositoryAdminServiceClient.DISABLED:RepositoryAdminServiceClient.ENABLED;

                                                            String statusText = oppositeStatus.substring(0, oppositeStatus.length() -1);

                                                %>
                                                <tr>
                                                    <td><%=repoNickName%></td>
                                                    <td><%=location%></td>
                                                    <td><%=status%></td>
                                                    <td>
                                                        <a class="icon-link" style="background-image: url(../admin/images/edit.gif);"
                                                           href="#" onclick="setSelectedRepoProperties('<%=location%>', '<%=repoNickName%>', null);
                                                           swapVisiblility('_div_tabs04-MR', '_div_tabs04-ER', 4);fillEditRepoTextBoxes();return false;"><fmt:message key="edit.button"/></a>
                                                    </td>
                                                    <td>
                                                        <a class="icon-link" style="background-image: url(../admin/images/delete.gif);"
                                                           href="#" onclick="setSelectedRepoProperties('<%=location%>', null, null);
                                                           showConfirmationDialogBox('<fmt:message key="confirm.removing.repo"/>',
                                                           removeRepository);return false;"><fmt:message key="remove"/></a>
                                                    </td>
                                                    <td>
                                                        <a class="icon-link"
                                                           <%=statusText.equals("Enable")?"style='background-image: url(images/activate.gif)';":"style='background-image: url(images/deactivate.gif)';"%>
                                                           href="#" onclick="setSelectedRepoProperties('<%=location%>', null, '<%=oppositeStatus%>');
                                                           showConfirmationDialogBox('<fmt:message key="confirm.enabling.repo.part1"/> '+ '<%=statusText%>' +' <fmt:message key="confirm.enabling.repo.part2"/>',
                                                           enableRepository);return false;">
                                                            <%
                                                                if(statusText.equals("Enable")){
                                                            %>
                                                                <fmt:message key="enable"/>
                                                            <%
                                                                } else {
                                                             %>
                                                                <fmt:message key="disable"/>
                                                            <%
                                                                }
                                                            %>
                                                           </a>
                                                    </td>
                                                </tr>
                                                <%
                                                        }
                                                    }
                                                %>
                                                </tbody>
                                                </table>
                                                <script type="text/javascript">
                                                    alternateTableRows('_table_repository_list', 'tableEvenRow', 'tableOddRow');
                                                </script>
                                        </div>
                                    </td></tr>
                                    </tbody>
                                </table>  </td>
                            </tr>
                            <%--<tr>--%>
                                <%--<td class="buttonRow">--%>
                                    <%--<input value="<fmt:message key="back.button"/>" tabindex="11" type="button"--%>
                                           <%--class="button"--%>
                                           <%--onclick="doBack('MR-MAIN')"--%>
                                           <%--id="_btn_back_repository">--%>
                                <%--</td>--%>
                            <%--</tr>--%>
                        </tbody>
                     </table>
                </div>

                <div id="_div_tabs04-AR" style="display:none">
                    <table class="styledLeft" cellspacing="1" width="100%"
                               id="_table_add_repositories" style="margin-left: 0px;">
                        <thead>
                            <tr>
                                <th><fmt:message key="add.new.repository"/></th>
                            </tr>
                        </thead>
                        <tbody>
                            <tr>
                                <td><table class="normal" cellspacing="1" width="100%" id="_table_add_repository"
                                       style="margin-left: 0px;">
                                    <tbody>
                                    <tr><td><font color="#707277"><i><fmt:message key="add.repo.desciption"/></i></font></td></tr>
                                    <br/>
                                    <tr>
                                        <td>
                                            <table class="normal" width="100%">
                                                <tbody>
                                                <tr>
                                                    <td><fmt:message key="name"/>:&nbsp;</td>
                                                    <td colspan="3">
                                                        <input id="_txt_repository_name" style="width: 390px;" class="toolsClass" type="text"/>
                                                    </td>
                                                    <td width="100%"></td>
                                                </tr>
                                                <tr>
                                                    <td><fmt:message key="location"/>:&nbsp;</td>
                                                    <td><input id="_chk_repository_location_url"  class="toolsClass"
                                                               name="repository_location" type="radio"
                                                               checked="checked" onchange="document.getElementById('_txt_repository_location_file').disabled = true;document.getElementById('_txt_repository_location_url').disabled = false;"></td>
                                                    <td><fmt:message key="url"/></td>
                                                    <td><input id="_txt_repository_location_url" style="width: 300px;" class="toolsClass" type="text" value="http://"/></td>
                                                    <td><font color="#707277"><i><fmt:message key="sample.uri.repo.desciption"/></i></font></td>
                                                </tr>
                                                <tr>
                                                    <td>&nbsp;</td>
                                                    <td><input id="_chk_repository_location_file"  class="toolsClass" name="repository_location" type="radio"
                                                            onchange="document.getElementById('_txt_repository_location_url').disabled = true;document.getElementById('_txt_repository_location_file').disabled = false;"></td>
                                                    <td><fmt:message key="file"/></td>
                                                    <td><input id="_txt_repository_location_file" style="width: 300px;"
                                                               class="toolsClass" type="text" disabled="disabled"/></td>
                                                    <td><font color="#707277"><i><fmt:message key="sample.local.repo.desciption"/></i></font></td>

                                                </tr>
                                                </tbody>
                                            </table>
                                        </td>
                                    </tr>
                                    </tbody>
                                </table>  </td>
                            </tr>
                            <tr>
                                <td class="buttonRow">
                                    <input value="<fmt:message key="add.button"/>" tabindex="11" type="button"
                                           class="button"
                                           onclick="validateAddRepositoryInputs();CARBON.showInfoDialog('<fmt:message key="adding.repository"/>....');addRepository();"
                                           id="_btn_add_repository">
                                    <input value="<fmt:message key="cancel.button"/>" tabindex="11" type="button"
                                           class="button"
                                           onclick="doBack('AR-MR')"
                                           id="_btn_cancel_add_repository">
                                </td>
                            </tr>
                        </tbody>
                    </table>
                </div>

                <div id="_div_tabs04-ER" style="display:none">
                    <table class="styledLeft" cellspacing="1" width="100%"
                               id="_table_edit_repositories" style="margin-left: 0px;">
                        <thead>
                            <tr>
                                <th><fmt:message key="edit.existing.repository"/></th>
                            </tr>
                        </thead>
                        <tbody>
                            <tr>
                                <td><table class="normal" cellspacing="1" width="100%" id="_table_edit_repository_normal"
                                       style="margin-left: 0px;">
                                    <tbody>
                                    <tr><td><font color="#707277"><i><fmt:message key="edit.repo.description"/></i></font></td></tr>
                                    <br/>
                                    <tr>
                                        <td>
                                            <table class="normal">
                                                <tbody>
                                                <tr>
                                                    <td><fmt:message key="name"/>:&nbsp;</td>
                                                    <td>
                                                        <input id="_txt_edit_repository_name" style="width: 300px;" class="toolsClass" type="text"/>
                                                    </td>
                                                </tr>
                                                <tr>
                                                    <td><fmt:message key="location"/>:&nbsp;</td>
                                                    <td>
                                                        <input id="_txt_edit_repository_location" style="width: 300px;" class="toolsClass" disabled="disabled" type="text"/>
                                                    </td>
                                                </tr>
                                                </tbody>
                                            </table>
                                        </td>
                                    </tr>
                                    </tbody>
                                </table>  </td>
                            </tr>
                            <tr>
                                <td class="buttonRow">
                                    <input value="<fmt:message key="edit.button"/>" tabindex="11" type="button"
                                           class="button"
                                           onclick="editRepository();"
                                           id="_btn_Finish_edit_repository">
                                    <input value="<fmt:message key="cancel.button"/>" tabindex="11" type="button"
                                           class="button"
                                           onclick="doBack('ER-MR')"
                                           id="_btn_cancel_edit_repository">
                                </td>
                            </tr>
                        </tbody>
                    </table>
                </div>
            </div>

		</div>
    &nbsp;</div>
</div>
<script type="text/javascript">
    YAHOO.util.Event.onDOMReady(function() {
        customAlternateTableRows('_table_installed_features_list', 'tableEvenRow', 'tableOddRow');
    });
</script>
</fmt:bundle>