var previouslySelectedRowColor;
var previouslySelectedRow;
var preveouslySelectedTableID;

var selectedRepoURL;
var updatedStatus;
var selectedRepoNickName;

var isSettingsChanged = false;

var tab01ActiveDivID;
var tab02ActiveDivID;
var tab03ActiveDivID;

var allowTabChange = true;

var addRepositoryOnCompleteReturnTabID;

var $myTabs;

$(function() {
    $myTabs = $("#tabs");

    $myTabs.tabs({
                select: function(event, ui) {
//                    if (!allowTabChange) {
////                        alert("Tab selection is disabled, while you are in the middle of a workflow");
//                    }
                    return allowTabChange;
                },

        show: function(event, ui) {
            var selectedTab = $myTabs.tabs('option', 'selected');
            if (selectedTab == '0') {
                //reloading the repositories combo-box
                loadSearchFeaturesDiv();
            } else if (selectedTab == "1") {
                //reload installed feature main page
                if (isSettingsChanged) {
                    swapVisiblility(tab02ActiveDivID, "_div_tabs02-IF", 2);
                }
            } else if (selectedTab == '2'){
                loadProfileHistory();
            }
        }
    });

    //Select a tab
    $myTabs.tabs('select', 0);

    //How to disable a tab
    //$myTabs.tabs('disable', 1);

    //How to get the selected tab
    //var tab_num = $myTabs.tabs('option', 'selected');

    $('#something').click(function() {
        var tab_num = $myTabs.tabs('option', 'selected');
        //var nextTab = tab_num + 1;
        //$myTabs.tabs('select', nextTab);
        doNext('AF');
    });

    $('#something_back').click(function() {
        //var tab_num = $myTabs.tabs('option', 'selected');
        //alert(tab_num);
        //var nextTab = tab_num + 1;
        //$myTabs.tabs('select', nextTab);
        doBack('AF_RF');
    });
});

function loadFeatures() {
    sessionAwareFunction(function() {
        var repoURL = document.getElementById('_select_repositoryCombo').value;
        var groupByCategory = 'false';
        var hideInstalled = 'true';
        var showLatest = 'false';
        if (document.getElementById('_chk_show_latest').checked) {
            showLatest = 'true';
        }
        wso2.wsf.Util.cursorWait();
        jQuery.noConflict();
        jQuery("#_div_tabs01-step-01-AF").load('available_features-ajaxprocessor.jsp',
        {   repoURL: repoURL,
            groupByCategory: groupByCategory,
            hideInstalled: hideInstalled,
            showLatest: showLatest
        },
                function (responseText, status, XMLHttpRequest) {
                    CARBON.closeWindow();
                    wso2.wsf.Util.cursorClear();
                    if (status != "success") {
                        CARBON.showErrorDialog("Backend Service is Unavailable");

                    } else if (responseText.search('compMgtErrorMsg') != -1) {
                        CARBON.showErrorDialog(responseText);

                    } else {
                        makeElementVisible("_div_tabs01-step-01-AF");
    //                    swapVisiblility("_div_tabs01-step-00-FR", "_div_tabs01-step-01-AF", 1);
                    }
                });
    });
}
                                            
function searchAvailableFeatures() {
    sessionAwareFunction(function() {
        var filterString = document.getElementById('_txt_AF_filterString').value;
        wso2.wsf.Util.cursorWait();
        jQuery.noConflict();
        jQuery("#_div_tabs01-step-01-AF").load('available_features-ajaxprocessor.jsp',
        {   queryType: 'searchQuery',
            filterStr: filterString
        },
                function (responseText, status, XMLHttpRequest) {
                    CARBON.closeWindow();
                    wso2.wsf.Util.cursorClear();
                    if (status != "success") {
                        CARBON.showErrorDialog("Backend Service is Unavailable");

                    } else if (responseText.search('compMgtErrorMsg') != -1) {
                        CARBON.showErrorDialog(responseText);
                    }
                });
     });
}

function searchInstalledFeatures() {
    sessionAwareFunction(function() {
        var filterString = document.getElementById('_txt_IF_filterString').value;
        wso2.wsf.Util.cursorWait();
        jQuery.noConflict();
        jQuery("#_div_installed_features_list").load('installed_features-ajaxprocessor.jsp',
        {   queryType: 'searchQuery',
            filterStr: filterString
        },
                function (responseText, status, XMLHttpRequest) {
                    wso2.wsf.Util.cursorClear();
                    if (status != "success") {
                        CARBON.showErrorDialog("Backend Service is Unavailable");

                    } else if (responseText.search('compMgtErrorMsg') != -1) {
                        CARBON.showErrorDialog(responseText);
                    }
                });
     });
}

function reviewInstallationPlan(selectedFeatures) {
    sessionAwareFunction(function() {
        wso2.wsf.Util.cursorWait();
        jQuery.noConflict();
        jQuery("#_div_tabs01-step-02-RF").load('review_install_action-ajaxprocessor.jsp',
        {
            selectedFeatures: selectedFeatures
        },
        function (responseText, status, XMLHttpRequest) {
            wso2.wsf.Util.cursorClear();
            if (status != "success") {
                CARBON.showErrorDialog("Backend Service is Unavailable");

            } else if (responseText.search('compMgtErrorMsg') != -1) {
                CARBON.showErrorDialog(responseText);

            } else {
                swapVisiblility("_div_tabs01-step-00-FR", "_div_tabs01-step-02-RF", 1);
            }
        });
    });
}

function loadLicenseInformation() {
    sessionAwareFunction(function() {
        wso2.wsf.Util.cursorWait();
        jQuery.noConflict();
        jQuery("#_div_tabs01-step-03-RL").load('display_licenses-ajaxprocessor.jsp',
            {
            },

            function (responseText, status, XMLHttpRequest) {
                wso2.wsf.Util.cursorClear();
                if (status != "success") {
                    CARBON.showErrorDialog("Backend Service is Unavailable");

                } else if (responseText.search('compMgtErrorMsg') != -1) {
                    CARBON.showErrorDialog(responseText);

                } else {
                    swapVisiblility("_div_tabs01-step-02-RF", "_div_tabs01-step-03-RL", 1);
                }
            });
    });
}

function performInstallation(actionType) {
    sessionAwareFunction(function() {
        allowTabChange = false;
        wso2.wsf.Util.cursorWait();
        jQuery.noConflict();
        jQuery.post('perform_installation-ajaxprocessor.jsp',
            {
                actionType: actionType
            },
            function (responseText, status, XMLHttpRequest) {
                allowTabChange = true;
                wso2.wsf.Util.cursorClear();
                if (status != "success") {
                    CARBON.showErrorDialog("Backend Service is Unavailable");
            
                } else if (responseText.search('compMgtErrorMsg') != -1) {
                    CARBON.showErrorDialog(responseText);

                } else {
                    swapVisiblility("_div_tabs01-step-04-INSTALLING", "_div_tabs01-step-05-IC", 1);
                }
            });
    });
}

function reviewUninstallationPlan(selectedFeatures) {
    sessionAwareFunction(function() {
        wso2.wsf.Util.cursorWait();
        jQuery.noConflict();
        jQuery("#_div_tabs02-RUF").load('review_uninstall_action-ajaxprocessor.jsp',
        {
            selectedFeatures: selectedFeatures
        },

                function (responseText, status, XMLHttpRequest) {
                    wso2.wsf.Util.cursorClear();
                    if (status != "success") {
                        CARBON.showErrorDialog("Backend Service is Unavailable");

                    } else if (responseText.search('compMgtErrorMsg') != -1) {
                        CARBON.showErrorDialog(responseText);

                    } else {
                        swapVisiblility("_div_tabs02-IF", "_div_tabs02-RUF", 2);
                    }
                });
     });
}

function reviewUninstallationFeaturesWithPropertiesPlan(featurePropery, featureValue) {
    sessionAwareFunction(function() {
        swapVisiblility("_div_tabs02-IF", "_div_tabs02-UNINSTALLING", 2);
        allowTabChange = false;
        wso2.wsf.Util.cursorWait();
        jQuery.noConflict();
        jQuery("#_div_tabs02-RUF").load('review_uninstall_action-ajaxprocessor.jsp',
        {
            featurePropery: featurePropery,
            featureValue: featureValue
        },

                function (responseText, status, XMLHttpRequest) {
                    allowTabChange = true;                    
                    wso2.wsf.Util.cursorClear();
                    if (status != "success") {
                        CARBON.showErrorDialog("Backend Service is Unavailable");

                    } else if (responseText.search('compMgtErrorMsg') != -1) {
                        CARBON.showErrorDialog(responseText);

                    } else {
                        swapVisiblility("_div_tabs02-UNINSTALLING", "_div_tabs02-UC", 2);
                    }
                });
     });
}

function performUninstallation(actionType) {
    sessionAwareFunction(function() {
        allowTabChange = false;        
        wso2.wsf.Util.cursorWait();
        jQuery.noConflict();
        jQuery.post('perform_installation-ajaxprocessor.jsp',
        {
            actionType:actionType
        },
                function (responseText, status, XMLHttpRequest) {
                    allowTabChange = true;                            
                    wso2.wsf.Util.cursorClear();
                    if (status != "success") {
                        CARBON.showErrorDialog("Backend Service is Unavailable");

                    } else if (responseText.search('compMgtErrorMsg') != -1) {
                        CARBON.showErrorDialog(responseText);

                    } else {
                        swapVisiblility("_div_tabs02-RUF", "_div_tabs02-UC", 2);
                    }
                });
     });
}

function loadProfileHistory(){
    if(document.getElementById("_div_tabs03-IH").innerHTML == ""){
        sessionAwareFunction(function() {
            allowTabChange = false;
            wso2.wsf.Util.cursorWait();
            jQuery.noConflict();
            jQuery("#_div_tabs03-IH").load('installation_history-ajaxprocessor.jsp',
            {
            },
                function (responseText, status, XMLHttpRequest) {
                    allowTabChange = true;
                    wso2.wsf.Util.cursorClear();
                    if (status != "success") {
                        CARBON.showErrorDialog("Backend Service is Unavailable");

                    } else if (responseText.search('compMgtErrorMsg') != -1) {
                        CARBON.showErrorDialog(responseText);

                    } else {
                        swapVisiblility("_div_tabs03-Loading-IH", "_div_tabs03-IH", 3);
                    }
                });
        });
    }
}

function performRevertOperation(actionType) {
    sessionAwareFunction(function() {
        allowTabChange = false;
        wso2.wsf.Util.cursorWait();
        jQuery.noConflict();
        jQuery.post('perform_installation-ajaxprocessor.jsp',
        {
            actionType:actionType
        },
                function (responseText, status, XMLHttpRequest) {
                    allowTabChange = true;                            
                    wso2.wsf.Util.cursorClear();
                    if (status != "success") {
                        CARBON.showErrorDialog("Backend Service is Unavailable");

                    } else if (responseText.search('compMgtErrorMsg') != -1) {
                        CARBON.showErrorDialog(responseText);

                    } else {
                        swapVisiblility("_div_tabs03-RP", "_div_tabs03-RC", 3);
                    }
                });
    });
}

function loadSelectedFeatureDetails(featureID, featureVersion, isInstalledFeature, divIDToShow, divIDToHide, tabNumber){
    sessionAwareFunction(function() {
        wso2.wsf.Util.cursorWait();
        jQuery.noConflict();
        jQuery("#" + divIDToShow).load('get_installed_feature_details-ajaxprocessor.jsp',
        {
            featureID:featureID,
            featureVersion:featureVersion,
            isInstalledFeature:isInstalledFeature,
            divIDToShow:divIDToShow,
            divIDToHide:divIDToHide,
            tabNumber:tabNumber
        },
                function (responseText, status, XMLHttpRequest) {
                    wso2.wsf.Util.cursorClear();
                    if (status != "success") {
                        CARBON.showErrorDialog("Backend Service is Unavailable");

                    } else if (responseText.search('compMgtErrorMsg') != -1) {
                        CARBON.showErrorDialog(responseText);

                    } else {
                        swapVisiblility(divIDToHide, divIDToShow, tabNumber);
                    }
                });
    });
}

function loadSearchFeaturesDiv() {
    sessionAwareFunction(function() {
        if (isSettingsChanged) {
            isSettingsChanged = false;

            wso2.wsf.Util.cursorWait();
            jQuery.noConflict();
            jQuery("#_div_tabs01-step-00-FR").load('search_repositories-ajaxprocessor.jsp',
            {},
                    function (responseText, status, XMLHttpRequest) {
                        wso2.wsf.Util.cursorClear();
                        if (status != "success") {
                            CARBON.showErrorDialog("Backend Service is Unavailable");

                        } else if (responseText.search('compMgtErrorMsg') != -1) {
                            CARBON.showErrorDialog(responseText);

                        } else {
                            swapVisiblility(tab01ActiveDivID, '_div_tabs01-step-00-FR', 1);
                        }
                    });
        }
    });
}

function loadRepositories() {
    sessionAwareFunction(function() {
        wso2.wsf.Util.cursorWait();
        jQuery.noConflict();
        jQuery("#_div_repository_list").load('manage_repositories-ajaxprocessor.jsp',
        {},
                function (responseText, status, XMLHttpRequest) {
                    wso2.wsf.Util.cursorClear();
                    if (status != "success") {
                        CARBON.showErrorDialog("Backend Service is Unavailable");

                    } else if (responseText.search('compMgtErrorMsg') != -1) {
                        CARBON.showErrorDialog(responseText);

                    } /*else {*/
//                        swapVisiblility('_div_tabs04-MAIN', '_div_tabs04-MR', 4);
//                    }
                });
    });
}

function validateAddRepositoryInputs(){
    return true;
}

function addRepository() {
    sessionAwareFunction(function() {    
        var nickName = document.getElementById('_txt_repository_name').value;
        var repoURL;
        var local;
        if(document.getElementById('_chk_repository_location_url').checked){
            local = false;            
            repoURL = document.getElementById('_txt_repository_location_url').value;
        } else {
            local = true;
            repoURL = document.getElementById('_txt_repository_location_file').value;
        }

        wso2.wsf.Util.cursorWait();
        jQuery.noConflict();
        jQuery.post('update_repository-ajaxprocessor.jsp',
        {   action: 'addRepo',
            repoURL: repoURL,
            nickName:nickName,
            local:local
        },

                function (responseText, status, XMLHttpRequest) {
                    CARBON.closeWindow();
                    wso2.wsf.Util.cursorClear();
                    if (status != "success") {
                        CARBON.showErrorDialog("Backend Service is Unavailable");

                    } else if (responseText.search('compMgtErrorMsg') != -1) {
                        CARBON.showErrorDialog(responseText);

                    } else {
                        isSettingsChanged = true;
                        if(addRepositoryOnCompleteReturnTabID == "AF"){
                            $myTabs.tabs('select', 0);                            
                            loadRepositories();
                            swapVisiblility('_div_tabs04-AR', '_div_tabs04-MR', 4);
                        } else {
                            swapVisiblility('_div_tabs04-AR', '_div_tabs04-MR', 4);
                            loadRepositories();
                        }
                    }
                });
    });
}

function editRepository() {
    sessionAwareFunction(function() {        
        var updatedNickName = document.getElementById('_txt_edit_repository_name').value;
        var updatedRepoURL = document.getElementById('_txt_edit_repository_location').value;

        wso2.wsf.Util.cursorWait();
        jQuery.noConflict();
        jQuery.post('update_repository-ajaxprocessor.jsp',
        {   action: 'editRepo',
            repoURL: selectedRepoURL,
            nickName: selectedRepoNickName,
            updatedRepoURL: updatedRepoURL,
            updatedNickName: updatedNickName
        },
                function (responseText, status, XMLHttpRequest) {
                    wso2.wsf.Util.cursorClear();
                    if (status != "success") {
                        CARBON.showErrorDialog("Backend Service is Unavailable");

                    } else if (responseText.search('compMgtErrorMsg') != -1) {
                        CARBON.showErrorDialog(responseText);

                    } else {
                        isSettingsChanged = true;
                        swapVisiblility('_div_tabs04-ER', '_div_tabs04-MR', 4);
                        loadRepositories();
                    }
                });
    });
}

function removeRepository() {
    sessionAwareFunction(function() {
        jQuery.noConflict();
        jQuery.post('update_repository-ajaxprocessor.jsp',
        {   action: 'removeRepo',
            repoURL: selectedRepoURL
        },

                function (responseText, status, XMLHttpRequest) {
                    if (status != "success") {
                        CARBON.showErrorDialog("Backend Service is Unavailable");

                    } else if (responseText.search('compMgtErrorMsg') != -1) {
                        CARBON.showErrorDialog(responseText);

                    } else {
                        isSettingsChanged = true;
                        loadRepositories();
                    }
                });
    });
}

function enableRepository() {
    sessionAwareFunction(function() {
        jQuery.noConflict();
        jQuery.post('update_repository-ajaxprocessor.jsp',
        {   action: 'enableRepo',
            repoURL: selectedRepoURL,
            enabled: updatedStatus
        },
                function (responseText, status, XMLHttpRequest) {
                    if (status != "success") {
                        CARBON.showErrorDialog("Backend Service is Unavailable");

                    } else if (responseText.search('compMgtErrorMsg') != -1) {
                        CARBON.showErrorDialog(responseText);

                    } else {
                        isSettingsChanged = true;
                        loadRepositories();
                    }
                });
    });
}

function getRevertPlan(timestamp){
    sessionAwareFunction(function() {
        wso2.wsf.Util.cursorWait();
        jQuery.noConflict();
        jQuery("#_div_tabs03-RP").load('revert_plan-ajaxprocessor.jsp',
        {   timestamp: timestamp
        },
                function (responseText, status, XMLHttpRequest) {
                    wso2.wsf.Util.cursorClear();
                    if (status != "success") {
                        CARBON.showErrorDialog("Backend Service is Unavailable");

                    } else if (responseText.search('compMgtErrorMsg') != -1) {
                        CARBON.showErrorDialog(responseText);

                    } else {
                        swapVisiblility('_div_tabs03-IH', '_div_tabs03-RP', 3);
                    }
                }); 
    });
}

function clearTableRowSelection() {
    previouslySelectedRow.style.backgroundColor = previouslySelectedRowColor;
    previouslySelectedRow = undefined;
    preveouslySelectedTableID = undefined;
}

function setSelectedRepoProperties(url, nickName, status) {
    selectedRepoURL = url;
    if (nickName != null) {
        selectedRepoNickName = nickName;
    }
    if (status != null) {
        updatedStatus = status;
    }
}

function fillEditRepoTextBoxes() {
    document.getElementById('_txt_edit_repository_name').value = selectedRepoNickName;
    document.getElementById('_txt_edit_repository_location').value = selectedRepoURL;

}

function showConfirmationDialogBox(message, yesCallback) {
    jQuery.noConflict();
    CARBON.showConfirmationDialog(message, yesCallback, null);
}

function isFeaturesSelected(elementName){
    var featureElements = document.getElementsByName(elementName);
    for (var j = 0; j < featureElements.length; j++) {
        if (featureElements[j].checked) {
            return true;
        }
    }
    return false;
}

function getSelectedFeatureList(elementName) {
    var checkBoxItems;
    var featureElements = document.getElementsByName(elementName);
    var selectedFeatureList = new Array();
    var index = 0;
    for (var j = 0; j < featureElements.length; j++) {
        if (!featureElements[j].disabled && featureElements[j].checked){
            var tr = featureElements[j].parentNode.parentNode;
            var childTr = tr;
            var childTrChkBox = featureElements[j]; 
            var parentTr = getParentTR(childTr);
            while (parentTr != null) {
                checkBoxItems = YAHOO.util.Dom.getElementsByClassName("checkbox-select", "INPUT", parentTr);
                if (checkBoxItems.length > 0 && checkBoxItems[0].checked) {
                    childTr = parentTr;
                    childTrChkBox = checkBoxItems[0]
                    parentTr = getParentTR(childTr);
                } else {
                    break;
                }
            }            
            selectedFeatureList[index] = childTrChkBox.value;
            index = index + 1;
        }
    }
    return selectedFeatureList;
}

function selecteAllAvailableFeatures(check) {
    var featureElements = document.getElementsByName('chkSelectFeaturesToInstall');
    for(var i = 0; i < featureElements.length; i++){
        if(check){
            featureElements[i].checked = true;
            document.getElementById("_btn_install_available_features_top").disabled = false;
            document.getElementById("_btn_install_available_features_bottom").disabled = false;            
        } else {
            featureElements[i].checked = false;
            document.getElementById("_btn_install_available_features_top").disabled = true;
            document.getElementById("_btn_install_available_features_bottom").disabled = true;         
        }
    }
}

function selecteAllUninstallableFeatures(check) {
    var featureElements = document.getElementsByName('chkSelectFeaturesToUninstall');
    for(var i = 0; i < featureElements.length; i++){
        if(check){
            featureElements[i].checked = true;
            document.getElementById("_btn_uninstall_installed_features_top").disabled = false;
            document.getElementById("_btn_uninstall_installed_features_bottom").disabled = false;
        } else {
            featureElements[i].checked = false;
            document.getElementById("_btn_uninstall_installed_features_top").disabled = true;
            document.getElementById("_btn_uninstall_installed_features_bottom").disabled = true;
        }
    }
}

function swapVisiblility(idToHide, idToShow, tabNumber) {
    makeElementInvisible(idToHide);
    makeElementVisible(idToShow);

    if (tabNumber == 1) {
        tab01ActiveDivID = idToShow;

    } else if (tabNumber == 2) {
        tab02ActiveDivID = idToShow;

    } else if (tabNumber == 3) {
        tab03ActiveDivID = idToShow;
    }
}

function makeElementVisible(id) {
    document.getElementById(id).style.display = "inline";
}

function makeElementInvisible(id) {
    document.getElementById(id).style.display = "none";
}


function doNext(context) {
    var selectedFeatures = undefined;

    if (context == "FR-AF") {
        loadFeatures();

    } else if (context == 'AF-RF') {
        selectedFeatures = getSelectedFeatureList("chkSelectFeaturesToInstall");
        if (selectedFeatures.length == 0) {
            CARBON.showWarningDialog("Please Select features to be installed.");
        } else {
            reviewInstallationPlan(selectedFeatures);
        }

    } else if (context == 'RF-RL') {
        loadLicenseInformation();

    } else if (context == 'UF-RUF') {
        selectedFeatures = getSelectedFeatureList("chkSelectFeaturesToUninstall");
        if (selectedFeatures.length == 0) {
            CARBON.showWarningDialog("Please Select features to be uninstalled.");
        } else {
            reviewUninstallationPlan(selectedFeatures);
        }

    } else if (context == "AU") {
        document.getElementById("_div_tabs02-step-01").style.display = "none";
        document.getElementById("_div_tabs02-step-02").style.display = "inline";
    }
}

function doBack(context) {

     if (context == "RF-AF") {
        swapVisiblility("_div_tabs01-step-02-RF", "_div_tabs01-step-00-FR", 1);

    } else if (context == 'RL-RF') {
        swapVisiblility("_div_tabs01-step-03-RL", "_div_tabs01-step-02-RF", 1);

    } else  if (context == "RL-AF") {
        swapVisiblility("_div_tabs01-step-03-RL", "_div_tabs01-step-00-FR", 1);

    } else if(context == "IC-AF"){
        swapVisiblility("_div_tabs01-step-05-IC", "_div_tabs01-step-00-FR", 1);

    } else if (context == "RUF-IF") {
        swapVisiblility("_div_tabs02-RUF", "_div_tabs02-IF", 2);

    } else if (context == "UC-IF") {
        swapVisiblility("_div_tabs02-UC", "_div_tabs02-IF", 2);

    } else if (context == "MR-MAIN") {
        swapVisiblility("_div_tabs04-MR", "_div_tabs04-MAIN", 4);

    } else if (context == "AR-MR") {
        if(addRepositoryOnCompleteReturnTabID == "AF"){
            $myTabs.tabs('select', 0);
        }
        swapVisiblility("_div_tabs04-AR", "_div_tabs04-MR", 4);

    } else if (context == "ER-MR") {
        swapVisiblility("_div_tabs04-ER", "_div_tabs04-MR", 4);
         
    } else if (context == "RP-IH"){
        swapVisiblility('_div_tabs03-RP', '_div_tabs03-IH', 3);
         
    } else if (context == "RC-IH"){
        swapVisiblility('_div_tabs03-RC', '_div_tabs03-IH', 3);            
    }
}

function doCancel() {

}

function doFinish(context) {
    var actionType;
    if (context == "IF") {
        actionType = document.getElementById("_hidden_RL_actionType").value;
        swapVisiblility('_div_tabs01-step-03-RL', '_div_tabs01-step-04-INSTALLING', 1);
        performInstallation(actionType);

    } else if (context == "UF") {
        actionType = document.getElementById("_hidden_UF_actionType").value;
        performUninstallation(actionType);
    }
}

function disableUninstallButtons(disable){
    document.getElementById("_btn_uninstall_installed_features_top").disabled = disable;
    document.getElementById("_btn_uninstall_installed_features_bottom").disabled = disable;    
}

function onChangeTopSelectBoxUninstallableFeatures(value){
    document.getElementById("_select_feature_type_bottom").value = value;

    if(value == "SELECTED_FEATURES"){
        var selectedFeatures = getSelectedFeatureList("chkSelectFeaturesToUninstall");
        if(selectedFeatures.length == 0){
            disableUninstallButtons(true);
        }
    } else if(value == "SERVER_FEATURES"){
        selecteAllUninstallableFeatures(false);
        disableUninstallButtons(false);
    } else if(value == "CONSOLE_FEATURES"){
        selecteAllUninstallableFeatures(false);
        disableUninstallButtons(false);
    }
}

function onChangeBottomSelectBoxUninstallableFeatures(value){
    document.getElementById("_select_feature_type_top").value = value;

    if(value == "SELECTED_FEATURES"){
        var selectedFeatures = getSelectedFeatureList("chkSelectFeaturesToUninstall");
        if(selectedFeatures.length == 0){
            disableUninstallButtons(true);
        }
    } else if(value == "SERVER_FEATURES"){
        selecteAllUninstallableFeatures(false);
        disableUninstallButtons(false);
    } else if(value == "CONSOLE_FEATURES"){
        selecteAllUninstallableFeatures(false);
        disableUninstallButtons(false);        
    }
}

function doUninstall() {
    var selectBoxValue = document.getElementById("_select_feature_type_top").value;

    if(selectBoxValue == "SELECTED_FEATURES"){
        var selectedFeatures = getSelectedFeatureList("chkSelectFeaturesToUninstall");
        if (selectedFeatures.length == 0) {
            CARBON.showWarningDialog("Please Select features to be uninstalled.");
        } else {
            reviewUninstallationPlan(selectedFeatures);
        }
        
    } else if(selectBoxValue == "SERVER_FEATURES"){
        reviewUninstallationFeaturesWithPropertiesPlan('org.wso2.carbon.p2.category.type', 'server');
    } else if(selectBoxValue == "CONSOLE_FEATURES"){
        reviewUninstallationFeaturesWithPropertiesPlan('org.wso2.carbon.p2.category.type', 'console');
    }
}

function doRevert(){
    var actionType = document.getElementById("_hidden_RP_actionType").value;
    performRevertOperation(actionType);
}

function doAcceptLicenses() {
//    if (context == "AF") {
        document.getElementById("_btn_finish_af_review_licenses").disabled = false;
//    } else if (context == "AU") {
//        document.getElementById("_btn_finish_au_review_licenses").disabled = false;
//    }
}

function doDeclineLicenses() {
//    if (context == "AF") {
        document.getElementById("_btn_finish_af_review_licenses").disabled = true;

//    } else if (context == "AU") {
//        document.getElementById("_btn_finish_au_review_licenses").disabled = true;
//    }
}

function checkBoxSelectedUninstall(chkBox) {
    selectInstallableFeatureTree(chkBox);
    var enableInstallButton = isFeaturesSelected('chkSelectFeaturesToUninstall');
    document.getElementById("_btn_uninstall_installed_features_top").disabled = !enableInstallButton;
    document.getElementById("_btn_uninstall_installed_features_bottom").disabled = !enableInstallButton;
    document.getElementById("_select_feature_type_top").value = "SELECTED_FEATURES";
    document.getElementById("_select_feature_type_bottom").value = "SELECTED_FEATURES";

}

function checkBoxSelectedinstall(chkBox) {
    selectInstallableFeatureTree(chkBox);
    var enableInstallButton = isFeaturesSelected('chkSelectFeaturesToInstall');
    document.getElementById("_btn_install_available_features_top").disabled = !enableInstallButton;
    document.getElementById("_btn_install_available_features_bottom").disabled = !enableInstallButton;

}

function submitenter(e, installed) {
    var keycode;
    if (window.event) {
        keycode = window.event.keyCode;
    } else if (e) {
        keycode = e.which;
    }

    if (keycode == 13){
        if(installed){
            searchInstalledFeatures();
        } else {
            searchAvailableFeatures();            
        }
        return true;
    } else {
        return true;
    }
}