<%@page import="org.wso2.carbon.utils.ServerConstants" %>
<%@ page import="org.wso2.carbon.user.mgt.ui.UserAdminClient" %>
<%@page import="org.apache.axis2.context.ConfigurationContext" %>
<%@page import="org.wso2.carbon.CarbonConstants" %>
<%@page import="org.wso2.carbon.ui.CarbonUIUtil" %>
<%@page import="java.util.ResourceBundle" %>
<%@page import="java.text.MessageFormat" %>
<%@ page import="org.wso2.carbon.ui.CarbonUIMessage" %>
<%@ page import="org.wso2.carbon.user.mgt.common.IUserAdmin" %>

<%@page import="java.util.Arrays"%><jsp:useBean id="roleBean" type="org.wso2.carbon.user.mgt.ui.RoleBean" scope="session"/>
<jsp:setProperty name="roleBean" property="*" />
<%
    String forwardTo = null;
    String roleName = roleBean.getRoleName();
    String BUNDLE = "org.wso2.carbon.userstore.ui.i18n.Resources";
    ResourceBundle resourceBundle = ResourceBundle.getBundle(BUNDLE, request.getLocale());
    String userType = (String) session.getAttribute("org.wso2.carbon.user.userType");
    try {
        String cookie = (String) session.getAttribute(ServerConstants.ADMIN_SERVICE_COOKIE);
        String backendServerURL = CarbonUIUtil.getServerURL(config.getServletContext(),
                session);
        ConfigurationContext configContext = (ConfigurationContext) config
                .getServletContext().getAttribute(CarbonConstants.CONFIGURATION_CONTEXT);
        IUserAdmin proxy = (IUserAdmin) CarbonUIUtil.getServerProxy(new UserAdminClient(
                cookie, backendServerURL, configContext), IUserAdmin.class, session);
        proxy.addRole(roleBean.getRoleName(), roleBean.getSelectedUsers(), roleBean
                .getSelectedPermissions());
        forwardTo = "role-mgt.jsp?ordinal=1";
        session.removeAttribute("roleBean");
        session.removeAttribute("org.wso2.carbon.user.userType");
    } catch (Exception e) {
        String message = MessageFormat.format(resourceBundle.getString("role.cannot.add"),
                new Object[] { roleName, e.getMessage() });
        CarbonUIMessage.sendCarbonUIMessage(message, CarbonUIMessage.ERROR, request);
        forwardTo = "add-step1.jsp?ordinal=2";
    }
%>

<%@page import="java.util.Arrays" %>
<%@ page import="org.wso2.carbon.user.mgt.common.IUserAdmin" %>
<script type="text/javascript">
    function forward() {
        location.href = "<%=forwardTo%>";
    }
</script>

<script type="text/javascript">
    forward();
</script>
